#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <time.h>
#ifdef USE_SYSLOG
#include <syslog.h>
#endif
#include "log.h"
#include "loadconfig.h"

void initlog(void){
	#ifdef USE_SYSLOG
	if(config[CF_USESYSLOG].valeur.integer == TRUE){
		openlog("arpalert: ", LOG_CONS, LOG_DAEMON);
	}
	#endif
}

void logmsg(int priority, const char *fmt, ...){
	va_list ap;
	char msg[4096];
	char s_time[128];
	FILE *fp;

	/* check if I do log this priority */
	if(priority > config[CF_LOGLEVEL].valeur.integer)return;

	#ifdef USE_SYSLOG
	if(config[CF_USESYSLOG].valeur.integer == TRUE){
		va_start(ap, fmt);
		vsyslog(priority, fmt, ap); 
		vsnprintf(msg, 4096, fmt, ap);
	}
	#endif

	if(config[CF_LOGFILE].valeur.string[0] != 0){
		if((fp = fopen(config[CF_LOGFILE].valeur.string, "a"))==NULL){
			fprintf(stderr, "[%s %d] Cant't open file [%s]",
				__FILE__, __LINE__, config[CF_LOGFILE].valeur.string);
			exit(1);
		}

		va_start(ap, fmt);
		vsnprintf(msg, 4096, fmt, ap);
		va_end(ap);
		msg[4095] = 0;
	
		//Oct  7 12:07:27 localhost arpalert: 
		snprintf(s_time, 128, "%d: ", (int)time(NULL));
		fputs(s_time, fp);
		fputs(msg, fp);
		fputs("\n\0", fp);
		fclose(fp);
	}

}

